SystemOrganization addCategory: #'Seaside-JSON-Core'!

WABrush subclass: #WAJsonBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

WAJsonBrush subclass: #WAJsonArrayBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonArrayBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:09'!
closeBrush
	self document closeArray! !

!WAJsonArrayBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:05'!
openBrush
	self document openArray! !

!WAJsonBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:08'!
closeBrush
	self subclassResponsibility! !

!WAJsonBrush methodsFor: 'accessing' stamp: 'pmm 8/24/2011 14:06'!
document
	^ canvas document! !

!WAJsonBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:00'!
openBrush
	self subclassResponsibility! !

!WAJsonBrush methodsFor: 'public' stamp: 'pmm 8/24/2011 14:07'!
with: anObject

	self openBrush.
	super with: [
		canvas render: anObject ].
	self closeBrush! !

WAJsonBrush subclass: #WAJsonObjectBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonObjectBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:10'!
closeBrush
	self document closeObject! !

!WAJsonObjectBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:05'!
openBrush
	self document openObject! !

WAJsonBrush subclass: #WAJsonValueBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonValueBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:20'!
closeBrush! !

!WAJsonValueBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:25'!
openBrush
	canvas write: ', ' ifCurrentBushIsKindOf: WAJsonValueBrush! !

WACanvas subclass: #WAJsonCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 13:57'!
array: aBlock
	^ (self brush: WAJsonArrayBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 11:39'!
key: a value: b! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 13:58'!
object: aBlock
	^ (self brush: WAJsonObjectBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 14:31'!
render: anObject
	self flush.
	anObject jsonOn: self document stream! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 14:25'!
value: aBlock
	^ (self brush: WAJsonValueBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'private' stamp: 'pmm 8/24/2011 14:24'!
write: aString ifCurrentBushIsKindOf: aClass
	(currentBrush isKindOf: aClass) ifTrue: [
		self document nextPutAll: aString ]! !

WADocument subclass: #WAJsonDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 12:08'!
closeArray
	stream nextPut: $]! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 12:08'!
closeObject
	stream nextPut: $}! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 14:04'!
openArray
	stream nextPut: $[! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 14:04'!
openObject
	stream nextPut: ${! !
